angular.module("umbraco").component("perplexAiMetadata", {
    templateUrl: "/App_Plugins/Perplex.AI.Assistant/metadata/perplex.ai-metadata.html",
    controller: [
        "languageResource",
        "perplexAIMetadataService",
        "notificationsService",
        function perplexAiMetadataController(languageResource, service, notificationsService) {
            this.isLoading = true;
            this.culture = null; // Selected culture
            this.cultures = []; // { name: <string>, isoCode: <string> }

            this.$onInit = function $onInit() {
                this.loadCultures().finally(function () {
                    this.isLoading = false;
                }.bind(this));
            }

            this.loadCultures = function loadCultures() {
                this.cultures = [];

                return languageResource.getAll().then(function (languages) {
                    if (Array.isArray(languages)) {
                        this.cultures = languages.map(function (language) {
                            return {
                                name: language.name,
                                isoCode: language.culture,
                            };
                        });

                        for (var i = 0; i < languages.length; i++) {
                            var language = languages[i];
                            if (language.isDefault) {
                                this.culture = language.culture;
                            }
                        }
                    }

                    return this.cultures;
                }.bind(this));
            }

            this.save = function save(node) {
                return service.save(node.id, node.culture, node.metaTitle, node.metaDescription).then(function () {
                    notificationsService.success(node.name + " metadata was updated successfully");
                });
            }

            this.generate = function generate(node, forceRefresh) {
                return service.generate(node.id, node.culture, !!forceRefresh);
            }
        }
    ]
});
